Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -7723,121 +6902,136 @@
 !--       All super-saturated water is then removed from the air
           IF ( humidity  .AND.  q_s <= qv1 )  THEN
-             surf_usm_h%r_canopy(m) = 0.0_wp
-          ENDIF
-
-!
-!--       Calculate coefficients for the total evapotranspiration
-!--       In case of water surface, set vegetation and soil fluxes to zero.
-!--       For pavements, only evaporation of liquid water is possible.
-          f_qsws_veg  = rho_lv * ( 1.0_wp - surf_usm_h%c_liq(m) ) /                                &
-                        ( surf_usm_h%r_a_green(m) + surf_usm_h%r_canopy(m) )
-          f_qsws_liq  = rho_lv * surf_usm_h%c_liq(m) / surf_usm_h%r_a_green(m)
-
-          f_qsws = f_qsws_veg + f_qsws_liq
+             surf%r_canopy(m) = 0.0_wp
+          ENDIF
+
+          IF ( upward ) THEN
+!--          Calculate the maximum possible liquid water amount on plants and bare surface. For
+!--          vegetated surfaces, a maximum depth of 0.2 mm is assumed, while paved surfaces might hold
+!--          up 1 mm of water. The liquid water fraction for paved surfaces is calculated after
+!--          Noilhan & Planton (1989), while the ECMWF formulation is used for vegetated surfaces and
+!--          bare soils.
+             m_liq_max = m_max_depth * ( surf%lai(m) )
+             surf%c_liq(m) = MIN( 1.0_wp, ( m_liq_usm_h(l)%val(m) / m_liq_max )**0.67 )
+
+!
+!--          Calculate coefficients for the total evapotranspiration
+!--          In case of water surface, set vegetation and soil fluxes to zero.
+!--          For pavements, only evaporation of liquid water is possible.
+             f_qsws_veg  = rho_lv * ( 1.0_wp - surf%c_liq(m) ) /                                  &
+                           ( surf%r_a_green(m) + surf%r_canopy(m) )
+             f_qsws_liq  = rho_lv * surf%c_liq(m) / surf%r_a_green(m)
+             f_qsws = f_qsws_veg + f_qsws_liq
+          ELSE
+             f_qsws_veg  = rho_lv * ( 1.0_wp - 0.0_wp ) / & !surf%c_liq(m) ) /                    &
+                                ( surf%r_a_green(m) + surf%r_canopy(m) )
+             f_qsws_liq  = 0._wp ! rho_lv * surf%c_liq(m) / surf%r_a_green(m)
+             f_qsws = f_qsws_veg + f_qsws_liq
+          ENDIF
 !
 !--       Calculate derivative of q_s for Taylor series expansion
-          e_s_dt = e_s * ( 17.269_wp / ( t_surf_green_h(m) - 35.86_wp ) - 17.269_wp                &
-                   * ( t_surf_green_h(m) - 273.16_wp ) / ( t_surf_green_h(m) - 35.86_wp )**2 )
-
+          e_s_dt = e_s * ( 17.269_wp / ( t_surf_green%val(m) - 35.86_wp ) - 17.269_wp             &
+                   * ( t_surf_green%val(m) - degc_to_k )                                          &
+                   / ( t_surf_green%val(m) - 35.86_wp )**2 )
           dq_s_dt = 0.622_wp * e_s_dt / ( surface_pressure - e_s_dt )
        ENDIF
 !
 !--    Add LW up so that it can be removed in prognostic equation
-       surf_usm_h%rad_net_l(m) = surf_usm_h%rad_sw_in(m)  - surf_usm_h%rad_sw_out(m) +             &
-                                 surf_usm_h%rad_lw_in(m)  - surf_usm_h%rad_lw_out(m)
+       surf%rad_net_l(m) = surf%rad_sw_in(m)  - surf%rad_sw_out(m) +                              &
+                           surf%rad_lw_in(m)  - surf%rad_lw_out(m)
 !
 !--    Numerator of the prognostic equation
 !--    Todo: Adjust to tile approach. So far, emissivity for wall (element 0) is used
-       coef_1 = surf_usm_h%rad_net_l(m) + ( 3.0_wp + 1.0_wp )                                      &
-               * surf_usm_h%emissivity(m,ind_veg_wall) * sigma_sb * t_surf_wall_h(m)**4            &
-               + f_shf * surf_usm_h%pt1(m) + lambda_surface * t_wall_h(nzb_wall,m)
-
-       IF ( ( .NOT. during_spinup ) .AND. (surf_usm_h%frac(m,ind_wat_win) > 0.0_wp ) )  THEN
-          coef_window_1 = surf_usm_h%rad_net_l(m) +  ( 3.0_wp + 1.0_wp )                           &
-                          * surf_usm_h%emissivity(m,ind_wat_win) * sigma_sb                        &
-                          * t_surf_window_h(m)**4 + f_shf_window * surf_usm_h%pt1(m)               &
-                          + lambda_surface_window * t_window_h(nzb_wall,m)
+!--    Rem: Coef +1 corresponds to -lwout included in calculation of radnet_l
+       coef_1 = surf%rad_net_l(m) + ( 3.0_wp + 1.0_wp )                                           &
+               * surf%emissivity(m,ind_veg_wall) * sigma_sb * t_surf_wall%val(m)**4               &
+               + f_shf * surf%pt1(m) + lambda_surface * t_wall%val(nzb_wall,m)
+
+       IF ( ( .NOT. during_spinup ) .AND. (surf%frac(m,ind_wat_win) > 0.0_wp ) )  THEN
+          coef_window_1 = surf%rad_net_l(m) +  ( 3.0_wp + 1.0_wp )                                &
+                          * surf%emissivity(m,ind_wat_win) * sigma_sb                             &
+                          * t_surf_window%val(m)**4 + f_shf_window * surf%pt1(m)                  &
+                          + lambda_surface_window * t_window%val(nzb_wall,m)
        ENDIF
-       IF ( ( humidity ) .AND. ( surf_usm_h%frac(m,ind_pav_green) > 0.0_wp ) )  THEN
-                coef_green_1 = surf_usm_h%rad_net_l(m) + ( 3.0_wp + 1.0_wp )                       &
-                               * surf_usm_h%emissivity(m,ind_pav_green) * sigma_sb                 &
-                               * t_surf_green_h(m)**4 + f_shf_green * surf_usm_h%pt1(m)            &
-                               + f_qsws * ( qv1 - q_s + dq_s_dt * t_surf_green_h(m) )              &
-                               + lambda_surface_green * t_green_h(nzb_wall,m)
+       IF ( ( humidity ) .AND. ( surf%frac(m,ind_pav_green) > 0.0_wp ) )  THEN
+          coef_green_1 = surf%rad_net_l(m) + ( 3.0_wp + 1.0_wp )                                  &
+                         * surf%emissivity(m,ind_pav_green) * sigma_sb                            &
+                         * t_surf_green%val(m)**4 + f_shf_green * surf%pt1(m)                     &
+                         + f_qsws * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m) )                 &
+                         + lambda_surface_green * t_green%val(nzb_wall,m)
        ELSE
-       coef_green_1 = surf_usm_h%rad_net_l(m) + ( 3.0_wp + 1.0_wp )                                &
-                      * surf_usm_h%emissivity(m,ind_pav_green) * sigma_sb * t_surf_green_h(m)**4   &
-                      + f_shf_green * surf_usm_h%pt1(m) + lambda_surface_green                     &
-                      * t_green_h(nzb_wall,m)
+          coef_green_1 = surf%rad_net_l(m) + ( 3.0_wp + 1.0_wp )                                  &
+                         * surf%emissivity(m,ind_pav_green) * sigma_sb * t_surf_green%val(m)**4   &
+                         + f_shf_green * surf%pt1(m) + lambda_surface_green                       &
+                         * t_green%val(nzb_wall,m)
        ENDIF
 !
 !--    Denominator of the prognostic equation
-       coef_2 = 4.0_wp * surf_usm_h%emissivity(m,ind_veg_wall) * sigma_sb * t_surf_wall_h(m)**3    &
+       coef_2 = 4.0_wp * surf%emissivity(m,ind_veg_wall) * sigma_sb * t_surf_wall%val(m)**3       &
                 + lambda_surface + f_shf / exner(k)
-       IF ( ( .NOT. during_spinup ) .AND. ( surf_usm_h%frac(m,ind_wat_win) > 0.0_wp ) )  THEN
-          coef_window_2 = 4.0_wp * surf_usm_h%emissivity(m,ind_wat_win) * sigma_sb *               &
-                          t_surf_window_h(m)**3 + lambda_surface_window + f_shf_window / exner(k)
+       IF ( ( .NOT. during_spinup ) .AND. ( surf%frac(m,ind_wat_win) > 0.0_wp ) )  THEN
+          coef_window_2 = 4.0_wp * surf%emissivity(m,ind_wat_win) * sigma_sb *                    &
+                          t_surf_window%val(m)**3 + lambda_surface_window + f_shf_window / exner(k)
        ENDIF
-       IF ( ( humidity ) .AND. ( surf_usm_h%frac(m,ind_pav_green) > 0.0_wp ) )  THEN
-          coef_green_2 = 4.0_wp * surf_usm_h%emissivity(m,ind_pav_green) * sigma_sb *              &
-                         t_surf_green_h(m)**3 + f_qsws * dq_s_dt + lambda_surface_green            &
+       IF ( ( humidity ) .AND. ( surf%frac(m,ind_pav_green) > 0.0_wp ) )  THEN
+          coef_green_2 = 4.0_wp * surf%emissivity(m,ind_pav_green) * sigma_sb *                   &
+                         t_surf_green%val(m)**3 + f_qsws * dq_s_dt + lambda_surface_green         &
                          + f_shf_green / exner(k)
        ELSE
-       coef_green_2 = 4.0_wp * surf_usm_h%emissivity(m,ind_pav_green) * sigma_sb                   &
-                      * t_surf_green_h(m)**3 + lambda_surface_green + f_shf_green / exner(k)
+          coef_green_2 = 4.0_wp * surf%emissivity(m,ind_pav_green) * sigma_sb                     &
+                         * t_surf_green%val(m)**3 + lambda_surface_green + f_shf_green / exner(k)
        ENDIF
 !
 !--    Implicit solution when the surface layer has no heat capacity, otherwise use RK3 scheme.
-       t_surf_wall_h_p(m) = ( coef_1 * dt_3d * tsc(2) + surf_usm_h%c_surface(m)                    &
-                              * t_surf_wall_h(m) )                                                 &
-                            / ( surf_usm_h%c_surface(m) + coef_2 * dt_3d * tsc(2) )
-       IF ( ( .NOT. during_spinup ) .AND. (surf_usm_h%frac(m,ind_wat_win) > 0.0_wp) )  THEN
-          t_surf_window_h_p(m) = ( coef_window_1 * dt_3d * tsc(2) + surf_usm_h%c_surface_window(m) &
-                                   * t_surf_window_h(m) ) /                                        &
-                                 ( surf_usm_h%c_surface_window(m) + coef_window_2 * dt_3d * tsc(2) )
+       t_surf_wall_p%val(m) = ( coef_1 * dt_3d * tsc(2) + surf%c_surface(m)                       &
+                            * t_surf_wall%val(m) )                                                &
+                            / ( surf%c_surface(m) + coef_2 * dt_3d * tsc(2) )
+       IF ( ( .NOT. during_spinup ) .AND. (surf%frac(m,ind_wat_win) > 0.0_wp) )  THEN
+          t_surf_window_p%val(m) = ( coef_window_1 * dt_3d * tsc(2) +                             &
+                                   surf%c_surface_window(m) * t_surf_window%val(m) ) /            &
+                                ( surf%c_surface_window(m) + coef_window_2 * dt_3d * tsc(2) )
        ENDIF
-       t_surf_green_h_p(m) = ( coef_green_1 * dt_3d * tsc(2) + surf_usm_h%c_surface_green(m)       &
-                               * t_surf_green_h(m) )                                               &
-                             /  ( surf_usm_h%c_surface_green(m) + coef_green_2 * dt_3d * tsc(2) )
+       t_surf_green_p%val(m) = ( coef_green_1 * dt_3d * tsc(2) +                                  &
+                               surf%c_surface_green(m) * t_surf_green%val(m) )                    &
+                             / ( surf%c_surface_green(m) + coef_green_2 * dt_3d * tsc(2) )
 !
 !--    Add RK3 term
-       t_surf_wall_h_p(m) = t_surf_wall_h_p(m) + dt_3d * tsc(3) *  surf_usm_h%tt_surface_wall_m(m)
-
-       t_surf_window_h_p(m) = t_surf_window_h_p(m) + dt_3d * tsc(3) *                              &
-                              surf_usm_h%tt_surface_window_m(m)
-
-       t_surf_green_h_p(m) = t_surf_green_h_p(m) + dt_3d * tsc(3) * surf_usm_h%tt_surface_green_m(m)
+       t_surf_wall_p%val(m) = t_surf_wall_p%val(m) + dt_3d * tsc(3) *                             &
+                            surf%tt_surface_wall_m(m)
+       t_surf_window_p%val(m) = t_surf_window_p%val(m) + dt_3d * tsc(3) *                         &
+                              surf%tt_surface_window_m(m)
+       t_surf_green_p%val(m) = t_surf_green_p%val(m) + dt_3d * tsc(3) *                           &
+                             surf%tt_surface_green_m(m)
 !
 !--    Store surface temperature on pt_surface. Further, in case humidity is used, store also
 !--    vpt_surface, which is, due to the lack of moisture on roofs, simply assumed to be the surface
 !--    temperature.
-       surf_usm_h%pt_surface(m) = ( surf_usm_h%frac(m,ind_veg_wall) * t_surf_wall_h_p(m)           &
-                                    + surf_usm_h%frac(m,ind_wat_win) * t_surf_window_h_p(m)        &
-                                    + surf_usm_h%frac(m,ind_pav_green) * t_surf_green_h_p(m)       &
-                                  ) / exner(k)
-
-       IF ( humidity )  surf_usm_h%vpt_surface(m) = surf_usm_h%pt_surface(m)
+       surf%pt_surface(m) = ( surf%frac(m,ind_veg_wall) * t_surf_wall_p%val(m)                    &
+                                 + surf%frac(m,ind_wat_win) * t_surf_window_p%val(m)              &
+                                 + surf%frac(m,ind_pav_green) * t_surf_green_p%val(m)             &
+                             ) / exner(k)
+
+       IF ( humidity )  surf%vpt_surface(m) = surf%pt_surface(m)
 !
 !--    Calculate true tendency
-       stend_wall = ( t_surf_wall_h_p(m) - t_surf_wall_h(m) - dt_3d * tsc(3) *                     &
-                      surf_usm_h%tt_surface_wall_m(m) ) / ( dt_3d  * tsc(2) )
-       stend_window = ( t_surf_window_h_p(m) - t_surf_window_h(m) - dt_3d * tsc(3) *               &
-                        surf_usm_h%tt_surface_window_m(m) ) / ( dt_3d  * tsc(2) )
-       stend_green = ( t_surf_green_h_p(m) - t_surf_green_h(m) - dt_3d * tsc(3) *                  &
-                       surf_usm_h%tt_surface_green_m(m) ) / ( dt_3d  * tsc(2) )
+       stend_wall = ( t_surf_wall_p%val(m) - t_surf_wall%val(m) - dt_3d * tsc(3) *                &
+                      surf%tt_surface_wall_m(m) ) / ( dt_3d  * tsc(2) )
+       stend_window = ( t_surf_window_p%val(m) - t_surf_window%val(m) - dt_3d * tsc(3) *          &
+                        surf%tt_surface_window_m(m) ) / ( dt_3d  * tsc(2) )
+       stend_green = ( t_surf_green_p%val(m) - t_surf_green%val(m) - dt_3d * tsc(3) *             &
+                       surf%tt_surface_green_m(m) ) / ( dt_3d  * tsc(2) )
 !
 !--    Calculate t_surf tendencies for the next Runge-Kutta step
        IF ( timestep_scheme(1:5) == 'runge' )  THEN
           IF ( intermediate_timestep_count == 1 )  THEN
-             surf_usm_h%tt_surface_wall_m(m)   = stend_wall
-             surf_usm_h%tt_surface_window_m(m) = stend_window
-             surf_usm_h%tt_surface_green_m(m)  = stend_green
+             surf%tt_surface_wall_m(m)   = stend_wall
+             surf%tt_surface_window_m(m) = stend_window
+             surf%tt_surface_green_m(m)  = stend_green
           ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
-             surf_usm_h%tt_surface_wall_m(m) = -9.5625_wp * stend_wall +                           &
-                                               5.3125_wp * surf_usm_h%tt_surface_wall_m(m)
-             surf_usm_h%tt_surface_window_m(m) = -9.5625_wp * stend_window +                       &
-                                                 5.3125_wp * surf_usm_h%tt_surface_window_m(m)
-             surf_usm_h%tt_surface_green_m(m) = -9.5625_wp * stend_green +                         &
-                                                5.3125_wp * surf_usm_h%tt_surface_green_m(m)
+             surf%tt_surface_wall_m(m) = -9.5625_wp * stend_wall +                                &
+                                               5.3125_wp * surf%tt_surface_wall_m(m)
+             surf%tt_surface_window_m(m) = -9.5625_wp * stend_window +                            &
+                                                 5.3125_wp * surf%tt_surface_window_m(m)
+             surf%tt_surface_green_m(m) = -9.5625_wp * stend_green +                              &
+                                                5.3125_wp * surf%tt_surface_green_m(m)
           ENDIF
        ENDIF
@@ -7845,143 +7039,135 @@
 !--    In case of fast changes in the skin temperature, it is required to update the radiative
 !--    fluxes in order to keep the solution stable
-       IF ( ( ( ABS( t_surf_wall_h_p(m)   - t_surf_wall_h(m) )   > 1.0_wp )   .OR.                 &
-            (   ABS( t_surf_green_h_p(m)  - t_surf_green_h(m) )  > 1.0_wp )   .OR.                 &
-            (   ABS( t_surf_window_h_p(m) - t_surf_window_h(m) ) > 1.0_wp ) )                      &
+       IF ( ( ( ABS( t_surf_wall_p%val(m)   - t_surf_wall%val(m) )   > 1.0_wp )   .OR.            &
+            (   ABS( t_surf_green_p%val(m)  - t_surf_green%val(m) )  > 1.0_wp )   .OR.            &
+            (   ABS( t_surf_window_p%val(m) - t_surf_window%val(m) ) > 1.0_wp ) )                 &
                .AND.  unscheduled_radiation_calls  )  THEN
           force_radiation_call_l = .TRUE.
        ENDIF
 !
-!--    Calculate fluxes
+!--    Calculate new fluxes
 !--    Rad_net_l is never used!
-       surf_usm_h%rad_net_l(m) = surf_usm_h%rad_net_l(m) + surf_usm_h%frac(m,ind_veg_wall)         &
-                                 * sigma_sb * surf_usm_h%emissivity(m,ind_veg_wall)                &
-                                 * ( t_surf_wall_h_p(m)**4 - t_surf_wall_h(m)**4 )                 &
-                                 + surf_usm_h%frac(m,ind_wat_win) * sigma_sb                       &
-                                 * surf_usm_h%emissivity(m,ind_wat_win)                            &
-                                 * ( t_surf_window_h_p(m)**4 - t_surf_window_h(m)**4 )             &
-                                 + surf_usm_h%frac(m,ind_pav_green) * sigma_sb                     &
-                                 * surf_usm_h%emissivity(m,ind_pav_green)                          &
-                                 * ( t_surf_green_h_p(m)**4 - t_surf_green_h(m)**4 )
-
-       surf_usm_h%wghf_eb(m)   = lambda_surface * ( t_surf_wall_h_p(m) - t_wall_h(nzb_wall,m) )
-       surf_usm_h%wghf_eb_green(m)  = lambda_surface_green                                         &
-                                      * ( t_surf_green_h_p(m) - t_green_h(nzb_wall,m) )
-       surf_usm_h%wghf_eb_window(m) = lambda_surface_window                                        &
-                                      * ( t_surf_window_h_p(m) - t_window_h(nzb_wall,m) )
+       surf%rad_net_l(m) = surf%rad_net_l(m) + surf%frac(m,ind_veg_wall)                          &
+                                 * sigma_sb * surf%emissivity(m,ind_veg_wall)                     &
+                                 * ( t_surf_wall_p%val(m)**4 - t_surf_wall%val(m)**4 )            &
+                                 + surf%frac(m,ind_wat_win) * sigma_sb                            &
+                                 * surf%emissivity(m,ind_wat_win)                                 &
+                                 * ( t_surf_window_p%val(m)**4 - t_surf_window%val(m)**4 )        &
+                                 + surf%frac(m,ind_pav_green) * sigma_sb                          &
+                                 * surf%emissivity(m,ind_pav_green)                               &
+                                 * ( t_surf_green_p%val(m)**4 - t_surf_green%val(m)**4 )
+
+       surf%wghf_eb(m)   = lambda_surface * ( t_surf_wall_p%val(m) - t_wall%val(nzb_wall,m) )
+       surf%wghf_eb_green(m)  = lambda_surface_green                                              &
+                                      * ( t_surf_green_p%val(m) - t_green%val(nzb_wall,m) )
+       surf%wghf_eb_window(m) = lambda_surface_window                                             &
+                                      * ( t_surf_window_p%val(m) - t_window%val(nzb_wall,m) )
 
 !
 !--    Ground/wall/roof surface heat flux
-       surf_usm_h%wshf_eb(m)   = - f_shf  * ( surf_usm_h%pt1(m) - t_surf_wall_h_p(m) / exner(k) )  &
-                                 * surf_usm_h%frac(m,ind_veg_wall) - f_shf_window                  &
-                                 * ( surf_usm_h%pt1(m) - t_surf_window_h_p(m) / exner(k) )         &
-                                 * surf_usm_h%frac(m,ind_wat_win) - f_shf_green                    &
-                                 * ( surf_usm_h%pt1(m) - t_surf_green_h_p(m) / exner(k) )          &
-                                 * surf_usm_h%frac(m,ind_pav_green)
+       surf%wshf_eb(m)   = - f_shf  * ( surf%pt1(m) - t_surf_wall_p%val(m) / exner(k) )           &
+                                 * surf%frac(m,ind_veg_wall) - f_shf_window                       &
+                                 * ( surf%pt1(m) - t_surf_window_p%val(m) / exner(k) )            &
+                                 * surf%frac(m,ind_wat_win) - f_shf_green                         &
+                                 * ( surf%pt1(m) - t_surf_green_p%val(m) / exner(k) )             &
+                                 * surf%frac(m,ind_pav_green)
 !
 !--    Store kinematic surface heat fluxes for utilization in other processes diffusion_s,
 !--    surface_layer_fluxes,...
-       surf_usm_h%shf(m) = surf_usm_h%wshf_eb(m) / c_p
+       surf%shf(m) = surf%wshf_eb(m) / c_p
 !
 !--    If the indoor model is applied, further add waste heat from buildings to the kinematic flux.
        IF ( indoor_model )  THEN
-          surf_usm_h%shf(m) = surf_usm_h%shf(m) + surf_usm_h%waste_heat(m) / c_p
+          surf%shf(m) = surf%shf(m) + surf%waste_heat(m) / c_p
        ENDIF
 
-
-       IF (surf_usm_h%frac(m,ind_pav_green) > 0.0_wp)  THEN
-
-
-          IF ( humidity )  THEN
-             surf_usm_h%qsws(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt * t_surf_green_h(m) - dq_s_dt  &
-                                                * t_surf_green_h_p(m) )
-
-             surf_usm_h%qsws_veg(m)  = - f_qsws_veg  * ( qv1 - q_s + dq_s_dt * t_surf_green_h(m)   &
-                                                         - dq_s_dt * t_surf_green_h_p(m) )
-
-             surf_usm_h%qsws_liq(m)  = - f_qsws_liq  * ( qv1 - q_s + dq_s_dt * t_surf_green_h(m)   &
-                                                         - dq_s_dt * t_surf_green_h_p(m) )
-
-          ENDIF
-
-!
-!--       Calculate the true surface resistance
-          IF ( .NOT.  humidity )  THEN
-             surf_usm_h%r_s(m) = 1.0E10_wp
-          ELSE
-             surf_usm_h%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt * t_surf_green_h(m) - dq_s_dt    &
-                                 * t_surf_green_h_p(m) ) / (surf_usm_h%qsws(m) + 1.0E-20)          &
-                                 - surf_usm_h%r_a_green(m)
-          ENDIF
-
-!
-!--       Calculate change in liquid water reservoir due to dew fall or evaporation of liquid water
-          IF ( humidity )  THEN
-!
-!--          If precipitation is activated, add rain water to qsws_liq and qsws_soil according the
-!--          the vegetation coverage.
-!--          precipitation_rate is given in mm.
+       IF ( humidity .AND.  surf%frac(m,ind_pav_green) > 0.0_wp )  THEN!
+!--       Calculate true surface resistance
+          IF ( upward ) THEN
+             surf%qsws(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)               &
+                                                - dq_s_dt * t_surf_green_p%val(m) )
+             surf%qsws(m) = surf%qsws(m) / l_v
+             surf%qsws_veg(m)  = - f_qsws_veg  * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)      &
+                                                         - dq_s_dt * t_surf_green_p%val(m) )
+             surf%qsws_liq(m)  = - f_qsws_liq  * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)      &
+                                                         - dq_s_dt * t_surf_green_p%val(m) )
+             surf%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)                 &
+                                 - dq_s_dt * t_surf_green_p%val(m) ) /                            &
+                                 (surf%qsws(m) + 1.0E-20) - surf%r_a_green(m)
              IF ( precipitation )  THEN
-
-!
+!--             Calculate change in liquid water reservoir due to dew fall or evaporation of liquid water
+!--             If precipitation is activated, add rain water to qsws_liq and qsws_soil according the
+!--             the vegetation coverage. Precipitation_rate is given in mm.
 !--             Add precipitation to liquid water reservoir, if possible. Otherwise, add the water
 !--             to soil. In case of pavements, the exceeding water amount is implicitely removed as
 !--             runoff as qsws_soil is then not used in the soil model
-                IF ( m_liq_usm_h%var_usm_1d(m) /= m_liq_max )  THEN
-                   surf_usm_h%qsws_liq(m) = surf_usm_h%qsws_liq(m)                                 &
-                                            + surf_usm_h%frac(m,ind_pav_green)                     &
-                                            * prr(k+k_off,j+j_off,i+i_off) * hyrho(k+k_off)        &
+                IF ( m_liq_usm_h(l)%val(m) /= m_liq_max )  THEN
+                   surf%qsws_liq(m) = surf%qsws_liq(m)                                            &
+                                            + surf%frac(m,ind_pav_green)                          &
+                                            * prr(k+k_off,j+j_off,i+i_off) * hyrho(k+k_off)       &
                                             * 0.001_wp * rho_l * l_v
-               ENDIF
-
+                ENDIF
              ENDIF
-
 !
 !--          If the air is saturated, check the reservoir water level
-             IF ( surf_usm_h%qsws(m) < 0.0_wp )  THEN
-!
-!--             Check if reservoir is full (avoid values > m_liq_max) In that case, qsws_liq goes to
-!--             qsws_soil. In this case qsws_veg is zero anyway (because c_liq = 1), so that tend is
-!--             zero and no further check is needed
-                IF ( m_liq_usm_h%var_usm_1d(m) == m_liq_max )  THEN
-!                  surf_usm_h%qsws_soil(m) = surf_usm_h%qsws_soil(m) + surf_usm_h%qsws_liq(m)
-                   surf_usm_h%qsws_liq(m)  = 0.0_wp
+             IF ( surf%qsws(m) < 0.0_wp )  THEN
+!
+!--                Check if reservoir is full (avoid values > m_liq_max) In that case, qsws_liq goes to
+!--                qsws_soil. In this case qsws_veg is zero anyway (because c_liq = 1), so that tend is
+!--                zero and no further check is needed
+                IF ( m_liq_usm_h(l)%val(m) == m_liq_max )  THEN
+                   surf%qsws_liq(m)  = 0.0_wp
                 ENDIF
-
-!
+!--                In case qsws_veg becomes negative (unphysical behavior), let the water enter the
+!--                liquid water reservoir as dew on the plant
+                IF ( surf%qsws_veg(m) < 0.0_wp )  THEN
+                   surf%qsws_liq(m) = surf%qsws_liq(m) + surf%qsws_veg(m)
+                   surf%qsws_veg(m) = 0.0_wp
+                ENDIF
+             ENDIF
+
+             tend = - surf%qsws_liq(m) * drho_l_lv
+             m_liq_usm_h_p(l)%val(m) = m_liq_usm_h(l)%val(m) + dt_3d *                            &
+                                       ( tsc(2) * tend + tsc(3) * tm_liq_usm_h_m(l)%val(m) )
+!
+!--             Check if reservoir is overfull -> reduce to maximum
+!--             (conservation of water is violated here)
+             m_liq_usm_h_p(l)%val(m) = MIN( m_liq_usm_h_p(l)%val(m), m_liq_max )
+!
+!--             Check if reservoir is empty (avoid values < 0.0) (conservation of water is violated here)
+             m_liq_usm_h_p(l)%val(m) = MAX( m_liq_usm_h_p(l)%val(m), 0.0_wp )
+!
+!--             Calculate m_liq tendencies for the next Runge-Kutta step
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                   tm_liq_usm_h_m(l)%val(m) = tend
+                ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
+                   tm_liq_usm_h_m(l)%val(m) = -9.5625_wp * tend +                                 &
+                                                  5.3125_wp * tm_liq_usm_h_m(l)%val(m)
+                ENDIF
+             ENDIF
+          ELSE
+!--          Downward and vertical surfaces
+             surf%qsws(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)               &
+                                                   - dq_s_dt * t_surf_green_p%val(m) )
+             surf%qsws(m) = surf%qsws(m) / l_v
+             surf%qsws_veg(m)  = - f_qsws_veg  * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)      &
+                                                   - dq_s_dt * t_surf_green_p%val(m) )
+             surf%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt * t_surf_green%val(m)                 &
+                                                  - dq_s_dt * t_surf_green_p%val(m) ) /           &
+                                                   (surf%qsws(m) + 1.0E-20)  - surf%r_a_green(m)
+             surf%qsws_liq(m) = 0._wp  ! - f_qsws_liq  * ( qv1 - q_s + dq_s_dt * t_surf_green_h(m)&
+!                                                  - dq_s_dt * t_surf_green_h_p(m) )
+!--          If the air is saturated, check the reservoir water level
+             IF ( surf%qsws(m) < 0.0_wp )  THEN
 !--             In case qsws_veg becomes negative (unphysical behavior), let the water enter the
 !--             liquid water reservoir as dew on the plant
-                IF ( surf_usm_h%qsws_veg(m) < 0.0_wp )  THEN
-                   surf_usm_h%qsws_liq(m) = surf_usm_h%qsws_liq(m) + surf_usm_h%qsws_veg(m)
-                   surf_usm_h%qsws_veg(m) = 0.0_wp
+                IF ( surf%qsws_veg(m) < 0.0_wp )  THEN
+                   surf%qsws_veg(m) = 0.0_wp
                 ENDIF
              ENDIF
-
-             surf_usm_h%qsws(m) = surf_usm_h%qsws(m) / l_v
-
-             tend = - surf_usm_h%qsws_liq(m) * drho_l_lv
-             m_liq_usm_h_p%var_usm_1d(m) = m_liq_usm_h%var_usm_1d(m) + dt_3d *                     &
-                                           ( tsc(2) * tend + tsc(3) * tm_liq_usm_h_m%var_usm_1d(m) )
-!
-!--         Check if reservoir is overfull -> reduce to maximum (conservation of water is violated
-!--         here)
-             m_liq_usm_h_p%var_usm_1d(m) = MIN( m_liq_usm_h_p%var_usm_1d(m), m_liq_max )
-
-!
-!--         Check if reservoir is empty (avoid values < 0.0) (conservation of water is violated here)
-             m_liq_usm_h_p%var_usm_1d(m) = MAX( m_liq_usm_h_p%var_usm_1d(m), 0.0_wp )
-!
-!--         Calculate m_liq tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   tm_liq_usm_h_m%var_usm_1d(m) = tend
-                ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
-                   tm_liq_usm_h_m%var_usm_1d(m) = -9.5625_wp * tend +                              &
-                                                  5.3125_wp * tm_liq_usm_h_m%var_usm_1d(m)
-                ENDIF
-             ENDIF
-
           ENDIF
        ELSE
-          surf_usm_h%r_s(m) = 1.0E10_wp
+          surf%r_s(m) = 1.0E10_wp
        ENDIF
 !
